﻿Imports System.Data
Imports System.Data.OleDb

Partial Public Class ViewCart
    Inherits System.Web.UI.Page

    Protected strTotal As Double = 0
    Protected strSumTotal As Double = 0

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        BindGird()
        Me.lblSumTotal.Text = "Total Amount : " & FormatNumber(strSumTotal, 2)

    End Sub

    Protected Sub BindGird()

        Dim dt As DataTable = DirectCast(Session("myCart"), DataTable)
        Me.myGridView.DataSource = dt
        Me.myGridView.DataBind()

    End Sub

    Protected Sub myGridView_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles myGridView.RowCommand

        If e.CommandName = "Del" Then
            Dim RowsID As Integer = e.CommandArgument
            Dim dt As DataTable

            dt = DirectCast(Session("myCart"), DataTable)

            dt.Rows(RowsID).Delete()

            Session("myCart") = dt

            Response.Redirect("ViewCart.aspx")

        End If

    End Sub

    Protected Function getProductDet(ByVal strProductID As String) As DataTable

        Dim objConn As New OleDbConnection
        Dim dtAdapter As OleDbDataAdapter
        Dim dt As New DataTable

        Dim strConnString As String
        strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\database.mdb"
        objConn = New OleDbConnection(strConnString)
        objConn.Open()

        Dim strSQL As New StringBuilder
        strSQL.Append(" SELECT * FROM product ")
        strSQL.Append(" WHERE ProductID = " & strProductID & " ")

        dtAdapter = New OleDbDataAdapter(strSQL.ToString(), objConn)
        dtAdapter.Fill(dt)

        dtAdapter = Nothing

        objConn.Close()
        objConn = Nothing

        Return dt

    End Function


    Protected Sub myGridView_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles myGridView.RowDataBound

        If e.Row.RowType = DataControlRowType.DataRow Then

            '*** ProductID ***'
            Dim lblProductID As Label = DirectCast(e.Row.FindControl("lblProductID"), Label)
            If Not IsNothing(lblProductID) Then
                lblProductID.Text = e.Row.DataItem("ProductID")
            End If

            Dim dt As DataTable = getProductDet(e.Row.DataItem("ProductID"))

            '*** ProductName ***'
            Dim lblProductName As Label = DirectCast(e.Row.FindControl("lblProductName"), Label)
            If Not IsNothing(lblProductName) Then
                lblProductName.Text = dt.Rows(0)("ProductName")
            End If

            '*** Price ***'
            Dim lblPrice As Label = DirectCast(e.Row.FindControl("lblPrice"), Label)
            If Not IsNothing(lblPrice) Then
                lblPrice.Text = dt.Rows(0)("Price")
            End If

            '*** Qty ***'
            Dim lblQty As Label = DirectCast(e.Row.FindControl("lblQty"), Label)
            If Not IsNothing(lblQty) Then
                lblQty.Text = e.Row.DataItem("Qty")
            End If

            '*** Total ***'
            Dim lblTotal As Label = DirectCast(e.Row.FindControl("lblTotal"), Label)
            If Not IsNothing(lblTotal) Then
                strTotal = CDbl(e.Row.DataItem("Qty")) * CDbl(dt.Rows(0)("Price"))
                strSumTotal = CDbl(strSumTotal) + strTotal
                lblTotal.Text = FormatNumber(strTotal, 2)
            End If

            '*** Delete ***'
            Dim lnkDelete As LinkButton = DirectCast(e.Row.FindControl("lnkDelete"), LinkButton)
            If Not IsNothing(lnkDelete) Then
                lnkDelete.Text = "Delete"
                lnkDelete.CommandName = "Del"
                lnkDelete.CommandArgument = e.Row.RowIndex
                lnkDelete.Attributes.Add("OnClick", "return confirm('Delete this row?');")
            End If

        End If

    End Sub

    Protected Sub lnkClearCart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lnkClearCart.Click

        Session.Abandon()
        Response.Redirect("ViewCart.aspx")

    End Sub

    Protected Sub lnkCheckOut_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lnkCheckOut.Click

        Dim dt As DataTable = DirectCast(Session("myCart"), DataTable)

        If Not IsNothing(Session("myCart")) Then
            If dt.Rows.Count > 0 Then
                Me.pnlCheckOut.Visible = True
            End If
        End If

    End Sub

    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSave.Click

        Dim objConn As New OleDbConnection
        Dim strConnString As String
        Dim strSQL As String
        Dim dtAdapter As OleDbDataAdapter
        Dim dt1 As New DataTable
        Dim dt2 As DataTable
        Dim strOrderID As String = 0
        Dim i As Integer

        strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\database.mdb"
        objConn.ConnectionString = strConnString
        objConn.Open()

        '*** Insert to orders ***'
        strSQL = "INSERT INTO orders (OrderDate,Name,Address,Tel,Email) " & _
        " VALUES " & _
        " (@sOrderDate,@sName,@sAddress,@sTel,@sEmail)"

        Dim objCmd As New OleDbCommand(strSQL, objConn)
        objCmd.Parameters.Add("@sOrderDate", OleDbType.Date).Value = Now()
        objCmd.Parameters.Add("@sName", OleDbType.VarChar).Value = Me.txtName.Text
        objCmd.Parameters.Add("@sAddress", OleDbType.VarChar).Value = Me.txtAddress.Text
        objCmd.Parameters.Add("@sTel", OleDbType.VarChar).Value = Me.txtTel.Text
        objCmd.Parameters.Add("@sEmail", OleDbType.VarChar).Value = Me.txtEmail.Text
        objCmd.ExecuteNonQuery()

        '*** Select OrderID ***'
        strSQL = "SELECT Max(OrderID) As sOrderID FROM orders "
        dtAdapter = New OleDbDataAdapter(strSQL.ToString(), objConn)
        dtAdapter.Fill(dt1)
        If dt1.Rows.Count > 0 Then
            strOrderID = dt1.Rows(0)("sOrderID")
        End If

        '*** Insert to orders_detail ***'
        dt2 = DirectCast(Session("myCart"), DataTable)
        For i = 0 To dt2.Rows.Count - 1
            strSQL = "INSERT INTO orders_detail (OrderID,ProductID,Qty) " & _
            " VALUES " & _
            " ('" & strOrderID & "','" & dt2.Rows(i)("ProductID") & "','" & dt2.Rows(i)("Qty") & "')"
            With objCmd
                .Connection = objConn
                .CommandText = strSQL
                .CommandType = CommandType.Text
                .ExecuteNonQuery()
            End With
        Next

        objConn.Close()
        objConn = Nothing

        Session.Abandon()
        Response.Redirect("ViewOrders.aspx?OrderID=" & strOrderID)

    End Sub

End Class